// Learn cc.Class:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/life-cycle-callbacks.html

require('./recommender');

cc.Class({
    extends: cc.Component,

    properties: {
        // foo: {
        //     // ATTRIBUTES:
        //     default: null,        // The default value will be used only when the component attaching
        //                           // to a node for the first time
        //     type: cc.SpriteFrame, // optional, default is typeof default
        //     serializable: true,   // optional, default is true
        // },
        // bar: {
        //     get () {
        //         return this._bar;
        //     },
        //     set (value) {
        //         this._bar = value;
        //     }
        // },
        btn: {
            type: cc.Node,
            default: null
        },
        icons: [cc.SpriteFrame]
    },

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    start () {
        this.imageCache = {};
        let recommender = new Recommender({
            appid: 'wx7a59aadcb728eca4',
            openid: '23333',
            debug: true
        });
        recommender.onReady((isOpen, game) => {
            if (isOpen) {
                // 显示图标，并设置当前图标图片为game.icon地址对应图片
                // ....
                this.btn.active = true;
                let sprite = this.btn.getComponent(cc.Sprite);
                this.setImage(sprite, game.icon);
                this.btn.on(cc.Node.EventType.TOUCH_START, function() {
                    recommender.jumpToCurrentGame();
                }); // 绑定图标点击事件
            } else {
                this.btn.active = false;
                // 隐藏图标
            }

        });
        recommender.onChange(game => {
            console.log('game change to', game);
            let sprite = this.btn.getComponent(cc.Sprite);
            this.setImage(sprite, game.icon);
        });
    },

    setImage(sprite, url) {
        if (this.imageCache[url]) {
            sprite.spriteFrame = this.imageCache[url];
            this.btn.width = this.btn.height = 100;
        } else {
            let image = new Image();
            image.src = url;
            image.onload = () => {
                let texture = new cc.Texture2D();
                texture.initWithElement(image);
                this.imageCache[url] = sprite.spriteFrame = new cc.SpriteFrame(texture);
                this.btn.width = this.btn.height = 100;
            }
        }
    }

    // update (dt) {},
});
